; File 'bas_ATRconv_asm' -> 'ATRconv_rel'                       28.10.94 Jo

          section   bas

          xdef      id_flag

id_flag   dc.l      'qiiq'              ; $00 cv_id  ID-flag cv.id
          dc.w      QI_Liste-id_flag    ; $04 cv_qi1 IBM-Listen   1
          dc.w      QA_Liste-id_flag    ; $06 cv_qa1 Atari-Listen 1
          dc.w      0                   ; $08 cv_qi2 IBM-Listen   2  nicht gesetzt
          dc.w      0                   ; $0A cv_qa2 Atari-Listen 2  nicht gesetzt
          dc.w      ibm501E-id_flag     ; $0C cv_is0 IBM Boot Sector 0 ab $1E
;-          dc.w      0                   ; $0E Atari cv_as0 Boot Sector 0 nicht gesetzt

; ATR bersetzungs-Tabellen QL <-> IBM / Atari              05.06.91 Jo
; QI_Liste:  ` korrigiert
; CR -> SPACE

; QL -> IBM
QI_Liste
          dc.w      $0001,$0203,$0405,$0607,$0809,$0A0B,$0C0D,$0E0F
          dc.w      $1011,$1213,$1415,$1617,$1819,$1A1B,$1C1D,$1E1F
          dc.b      ' !"#$%&',$27,'()*+,-./0123456789:;<=>?'
          dc.b      '@ABCDEFGHIJKLMNOPQRSTUVWXYZ',$5B,$5C,$5D,'^_'
          dc.b      $9C,'abcdefghijklmnopqrstuvwxyz{|}~?'
          dc.w      $843F,$8682,$943F,$3F81,$87A4,$913F,$A085,$8389
          dc.w      $8A88,$8BA1,$8D8C,$A295,$93A3,$9796,$E19B,$9D60
          dc.w      $8E3F,$8F90,$993F,$ED9A,$80A5,$923F,$E0EB,$E93F
          dc.w      $E6E3,$E8AD,$A83F,$3F3F,$AEAF,$F8F6,$3F3F,$3F3F
          dc.w      $3F3F,$3F3F,$3F3F,$3F3F,$3F3F,$3F3F,$3F3F,$3F3F
          dc.w      $3F3F,$3F3F,$3F3F,$3F3F,$3F3F,$3F3F,$3F3F,$3F3F
          dc.w      $3F3F,$3F3F,$3F3F,$3F3F,$3F3F,$3F3F,$3F3F,$3F3F
          dc.w      $3F3F,$3F3F,$3F3F,$3F3F,$3F3F,$3F3F,$3F3F,$3F3F
; IBM -> QL
IQ_Liste
          dc.w      $0001,$0203,$0405,$0607,$0809,$0A0B,$0C20,$0E0F
          dc.w      $1011,$1213,$1415,$1617,$1819,$1A1B,$1C1D,$1E1F
          dc.b      ' !"#$%&',$27,'()*+,-./0123456789:;<=>?'
          dc.b      '@ABCDEFGHIJKLMNOPQRSTUVWXYZ',$5B,$5C,$5D,'^_'
          dc.b      $9F,'abcdefghijklmnopqrstuvwxyz{|}~'
          dc.w      $A887,$838E,$808D,$8288,$918F,$9092,$9594,$A0A2
          dc.w      $A38A,$AA98,$8497,$9B9A,$3FA4,$A79D,$609E,$9C3F
          dc.w      $8C93,$9699,$89A9,$3F3F,$B43F,$3F3F,$3FB3,$B8B9
          dc.w      $3F3F,$3F3F,$3F3F,$3F3F,$3F3F,$3F3F,$3F3F,$3F3F
          dc.w      $3F3F,$3F3F,$3F3F,$3F3F,$3F3F,$3F3F,$3F3F,$3F3F
          dc.w      $3F3F,$3F3F,$3F3F,$3F3F,$3F3F,$3F3F,$3F3F,$3F3F
          dc.w      $AC9C,$3FB1,$3F3F,$B03F,$B2AE,$3FAD,$3FA6,$3F3F
          dc.w      $3F3F,$3F3F,$3F3F,$BB3F,$BA3F,$3F3F,$3F3F,$3F20

; QL -> Atari
QA_Liste
          dc.w      $0001,$0203,$0405,$0607,$0809,$0A0B,$0C0D,$0E0F
          dc.w      $1011,$1213,$1415,$1617,$1819,$1A1B,$1C1D,$1E1F
          dc.b      ' !"#$%&',$27,'()*+,-./0123456789:;<=>?'
          dc.b      '@ABCDEFGHIJKLMNOPQRSTUVWXYZ',$5B,$5C,$5D,'^_'
          dc.b      'abcdefghijklmnopqrstuvwxyz{|}~',$BD
          dc.w      $84B0,$8682,$94B1,$B381,$87A4,$91B4,$A085,$8389
          dc.w      $8A88,$8BA1,$8D8C,$A295,$93A3,$9796,$9E9B,$9D60
          dc.w      $8EB7,$8F90,$99B8,$B29A,$80A5,$92B5,$E0EB,$E93F
          dc.w      $E6E3,$EDAD,$A83F,$DD3F,$AEAF,$F8F6,$0403,$0102
          dc.w      $3F3F,$3F3F,$3F3F,$3F3F,$3F3F,$3F3F,$3F3F,$3F3F
          dc.w      $3F3F,$3F3F,$3F3F,$3F3F,$3F3F,$3F3F,$3F3F,$3F3F
          dc.w      $3F3F,$3F3F,$3F3F,$3F3F,$3F3F,$3F3F,$3F3F,$3F3F
          dc.w      $3F3F,$3F3F,$3F3F,$3F3F,$3F3F,$3F3F,$3F3F,$3F3F
; Atari -> QL
AQ_Liste
          dc.w      $00BE,$BFBD,$BC05,$0607,$0809,$0A0B,$0C20,$0E0F
          dc.b      '0123456789',$1A,$1B,$1C,$1D,$1E,$1F
          dc.b      ' !"#$%&',$27,'()*+,-./'
          dc.b      '0123456789:;<=>?'
          dc.b      '@ABCDEFGHIJKLMNOPQRSTUVWXYZ',$5B,$5C,$5D,'^_'
          dc.b      $9F,'abcdefghijklmnopqrstuvwxyz{|}~?'
          dc.w      $A887,$838E,$808D,$8288,$918F,$9092,$9594,$A0A2
          dc.w      $A38A,$AA98,$8497,$9B9A,$3FA4,$A79D,$609E,$9C3F
          dc.w      $8C93,$9699,$89A9,$3F3F,$B43F,$3F3F,$3FB3,$B8B9
          dc.w      $8185,$A686,$8BAB,$3FA1,$A53F,$3F3F,$3F7F,$3F3F
          dc.w      $3F3F,$3F3F,$3F3F,$3F3F,$3F3F,$3F3F,$3F3F,$3F3F
          dc.w      $3F3F,$3F3F,$3F3F,$3F3F,$3F3F,$3F3F,$3FB6,$3F3F
          dc.w      $AC9C,$3FB1,$3F3F,$B03F,$3FAE,$3FAD,$3FB2,$3F3F
          dc.w      $3F3F,$3F3F,$3F3F,$BB3F,$BA3F,$3F3F,$3F3F,$3F3F
; ---------------------------------------------------------- Tabellen Ende
; IBM Startsector 0 DD / HD ab $1E bis $200
ibm501E dc.w    $0000,$0000,$0000,$0000,$2910,$1E22
        dc.b    $12,'ATRdev Jo  FAT12   '
        dc.l    $FA33C08E,$D0BC007C,$1607BB78,$0036C537
        dc.l    $1E561653,$BF3E7CB9,$0B00FCF3,$A4061FC6
        dc.l    $45FE0F8B,$0E187C88,$4DF98947,$02C7073E
        dc.l    $7CFBCD13,$727933C0,$3906137C,$74088B0E
        dc.l    $137C890E,$207CA010,$7CF72616,$7C03061C
        dc.l    $7C13161E,$7C03060E,$7C83D200,$A3507C89
        dc.l    $16527CA3,$497C8916,$4B7CB820,$00F72611
        dc.l    $7C8B1E0B,$7C03C348,$F7F30106,$497C8316
        dc.l    $4B7C00BB,$00058B16,$527CA150,$7CE89200
        dc.l    $721DB001,$E8AC0072,$168BFBB9,$0B00BEE6
        dc.l    $7DF3A675,$0A8D7F20,$B90B00F3,$A67418BE
        dc.l    $9E7DE85F,$0033C0CD,$165E1F8F,$048F4402
        dc.l    $CD195858,$58EBE88B,$471A4848,$8A1E0D7C
        dc.l    $32FFF7E3,$0306497C,$13164B7C,$BB0007B9
        dc.l    $03005052,$51E83A00,$72D8B001,$E8540059
        dc.l    $5A5872BB,$05010083,$D200031E,$0B7CE2E2
        dc.l    $8A2E157C,$8A16247C,$8B1E497C,$A14B7CEA
        dc.l    $00007000,$AC0AC074,$29B40EBB,$0700CD10
        dc.l    $EBF23B16,$187C7319,$F736187C,$FEC28816
        dc.l    $4F7C33D2,$F7361A7C,$8816257C,$A34D7CF8
        dc.l    $C3F9C3B4,$028B164D,$7CB106D2,$E60A364F
        dc.l    $7C8BCA86,$E98A1624,$7C8A3625,$7CCD13C3
        dc.b    $0D,$0A,'Non-System disk or disk error',$0D
        dc.b    $0A,'Replace and press any key when ready',$0D,$0A,$00
        dc.b    'IBMBIO  COMIBMDOS  COM'
        dc.w    $0000,$55AA

      end
