;         ATR Basic Befehle                       Jo 27.11.91
; fdd_conv auf $48 gendert   09.12.91
; ATR_CONV ohne fdd_cadr wegen Platz im Sandy-Eprom 07.01.92

          section   bas

          xdef      atrdev1
          xdef      atruse
          xdef      atrtrack
          xdef      atrconv

          xref      iou_use
          xref      iou_flnk
          xref      ut_gxin1
;-          xref      ut_gxli1
          xref      ut_gxnm1
          xref      gu_achp0
          xref      gu_rchp
          xref      init_new

          include   'flp1_dd_at_ddlk'
          include   'flp1_keys_karte'
          include   'flp1_keys_cv'

;-          include   'flp1_mac_assert'

;+++
; Basic - Erweiterungen ATR_USE, ATR_TRACK, ATR_DEV, ATR_CONV
;---
;         BASIC - Procedure   'ATR_USE'
atruse    move.l    #'ATR0',d7
          jmp       iou_use(pc)

;         BASIC - Procedure   'ATR_TRACK'
atrtrack  bsr.s     atr_gpar
            bne.s   cv_rts
          move.w    $00(a6,a1.l),fdd_maxt-$0018(a0)         ; $00BA(a0)
          bra.s     cv_ok

;         BASIC - Procedure   'ATR_DEV', 2. Aufruf
atrdev1   bsr.s     atr_flnk            ; Link -> a0
            bne.s   cv_rts
          lea       -$0018(a0),a3       ; ATR0 ddd
          movea.l   fdd_flpl(a3),a0     ; FLP0 ddd
          st        fdd_new(a3)
          jmp       init_new(pc)        ; Parameter von FLP0 ddd holen

;         BASIC - Procedure   'ATR_CONV'
atrconv
          bsr.s     atr_gpar            ; get 1 word integer + link
            bne.s   cv_err
          lea       fdd_cadr-$18(a0),a2
          lea       fdd_conv-$18(a0),a3
          move.l    (a2),d3             ; Listenadresse gesetzt ?
            ble.s   err_ni              ; ..nein, ERR_NI
          moveq     #-$0F,d0            ; ERR_BP
          move.w    0(a6,a1.l),d1       ; Parameter 0..2 ?
            bmi.s   cv_err              ; <0
          moveq     #2,d2
          cmp.w     d2,d1
            bgt.s   cv_err              ; >2
          cmp.b     d2,d1               ; Liste 1 oder 0
            blt.s   cv_lis1             ; ..ja, immer da
          movea.l   d3,a1
          tst.l     cv_qi2(a1)          ; Listen 2 vorhanden ?
            beq.s   cv_err              ; ..nein, ERR_BP
cv_lis1   move.b    d1,(a3)             ; fdd_conv ATR_CONV setzen
cv_ok     moveq     #0,d0
cv_rts    rts
err_ni
          sf        (a3)                ; fdd_conv false
          moveq     #-$13,d0            ; ERR_NI
cv_err    tst.l     d0
          rts

atr_gpar
          jsr       ut_gxin1(pc)
            bne.s   cv_err
atr_flnk
          move.l    #'ATR0',d7
          jmp       iou_flnk(pc)
      end

