; FAT lesen / FAT schreiben                                26.10.94 Jo
; DD / HD, mupd(a4) richtig setzen

          section   cv

          xdef      cv_rfat
          xdef      cv_wfat

          include   'flp1_dd_fq_ddlk'
;+++
; FAT lesen    d0.w -> d0.w  (d0.msw alte FAT-Nr vor Aufruf)
;
;     d0 cr     FAT-Eintrag / nchster FAT-Eintrag
;     a4 c  p   phys def block
;     error return none
;---
cv_rfat
rft.reg   reg       d1-d2/a1
          movem.l   rft.reg,-(sp)
          lea       fdd_hfat(a4),a1     ; Zeiger auf FAT
          move.w    d0,d1
          swap      d0                  ; alte FAT-Nr retten in msw
          move.w    d1,d0
          asr.w     #$01,d1                     
          add.w     d0,d1
          move.b    $01(a1,d1.w),d2
          asl.w     #$08,d2
          move.b    $00(a1,d1.w),d2
          btst      #$00,d0
            beq.s   rft_gera
          asr.w     #$04,d2
rft_gera  andi.w    #$0FFF,d2
          move.w    d2,d0
          movem.l   (sp)+,rft.reg
          rts

;+++
; FAT screiben    d2.lsw -> d2.msw
;
;     d2 c  p   msw Adresse / lsw FAT-Eintrag
;     a4 c  p   phys def block
;     error return none
;---
cv_wfat
wft.reg   reg       d0-d3/a1
          movem.l   wft.reg,-(sp)
          lea       fdd_hfat(a4),a1     ; Zeiger auf FAT
          move.l    d2,d1               ; d2.w FAT Eintrag
          swap      d1
          move.w    d1,d3               ; d3.w FAT Adresse
          asr.w     #$01,d3
          add.w     d1,d3
          move.b    $01(a1,d3.w),d0
          asl.w     #$08,d0
          move.b    $00(a1,d3.w),d0
          btst      #$00,d1
            bne.s   wft_unge
          andi.w    #$F000,d0
          bra.s     wft_shft
wft_unge
          andi.w    #$000F,d0
          asl.w     #$04,d2
wft_shft
          or.w      d2,d0
          move.b    d0,$00(a1,d3.w)
          asr.w     #$08,d0
          move.b    d0,$01(a1,d3.w)

          move.l    d3,d0
          addq.w    #1,d3
          divu      #$200,d0            ; 0..1ff=0, 200..3ff=1, 400..5ff=2
          divu      #$200,d3            ; 0..1ff=0, 200..3ff=1, 400..5ff=2
          st        fdd_mupd(a4,d0.w)
          st        fdd_mupd(a4,d3.w)

          movem.l   (sp)+,wft.reg
          rts
     end
