; Umwandlung IBM-Uhr <-> QL-Uhr

          section   cv

          xdef      cv_iquhr
          xdef      cv_qiuhr

          xref      cv_d1w
          xref      cv_d1l
;+++
; Umwandlung IBM (a2) -> QL Uhr d1.l
;
;         d1.l   r  QL Uhrzeit
;         a2   c    Zeiger auf IBM - dir Eintrag
;         error return none
;---
cv_iquhr
iqu.reg   reg       d0/d3
          movem.l   iqu.reg,-(sp)
          moveq     #$00,d0
          move.b    $0019(a2),d0
          lsr.b     #$01,d0                     
          addi.b    #$13,d0                     
          move.l    d0,d1                       
          mulu      #$016D,d1           ; 365
          move.l    d1,d3
          move.w    $0018(a2),d1
          jsr       cv_d1W(pc)
          exg       d1,d3
          lsr.w     #$05,d3
          andi.w    #$000F,d3
          divu      #$0004,d0                   
          swap      d0                          
          cmpi.w    #$0003,d0                   
          bne.s     x0478
          cmpi.w    #$0002,d3
          ble.s     x0478
          addq.l    #$01,d1                     
x0478     clr.w     d0
          swap      d0                          
          add.l     d0,d1                       
          subq.w    #$01,d3
          asl.w     #$01,d3
          moveq     #0,d0
          move.w    x04F0(PC,d3.w),d0
          add.l     d0,d1                       
          move.b    $0018(a2),d0
          andi.w    #$001F,d0                   
          subq.w    #$01,d1                     
          add.l     d0,d1                       
          moveq     #$18,d0             ; 24
          bsr.s     x0508
          move.b    $0017(a2),d0
          lsr.b     #$03,d0                     
          add.l     d0,d1                       
          moveq     #$3C,d0             ; 60
          bsr.s     x0508
          exg       d0,d1                       
          move.w    $0016(a2),d1
          jsr       cv_d1W(pc)
          lsr.w     #$05,d1                     
          andi.w    #$003F,d1                   
          add.l     d0,d1                       
          moveq     #$3C,d0             ; 60
          bsr.s     x0508
          move.b    $0016(a2),d0
          andi.b    #$1F,d0                     
          lsl.b     #$01,d0                     
          add.l     d0,d1               ; d1.L = QL-Zeit
          movem.l   (sp)+,iqu.reg
          rts
;
x04F0     dc.w      $0000,$001F,$003B,$005A
          dc.w      $0078,$0097,$00B5,$00D4
          dc.w      $00F3,$0111,$0130,$014E
;
x0508     move.l    d1,-(a7)
          mulu      d0,d1                       
          move.l    d1,-(a7)                    
          move.l    $0004(a7),d1                
          swap      d1                          
          mulu      d0,d1                       
          swap      d1                          
          add.l     (a7)+,d1                    
          addq.w    #$04,a7                     
          rts
;+++
; Umwandlung QL-Uhr -> IBM-Uhr
;         d1.l cr   QL- Uhr / IBM - Uhr
;         error return none
;---
cv_qiuhr
qiu.reg   reg       d0/d2-d5
          tst.l     d1
            beq.s   qiu_rts
          movem.l   qiu.reg,-(sp)
          bsr.s     x056C
          moveq     #$00,d0                     
          move.w    d2,d0                       
          subi.w    #$07BC,d0           ; 1980
          ror.l     #$07,d0                     
          addq.w    #$01,d4                     
          swap      d4                          
          andi.l    #$000F0000,d4               
          asl.l     #$05,d4                     
          or.l      d4,d0                       
          andi.l    #$0000001F,d1               
          swap      d1                          
          or.l      d1,d0                       
          andi.l    #$001F0000,d2               
          asr.l     #$05,d2                     
          or.l      d2,d0                       
          move.w    d3,d2                       
          andi.l    #$0000003F,d2               
          asl.l     #$05,d2                     
          or.l      d2,d0                       
          swap      d3                          
          asr.w     #$01,d3                     
          andi.l    #$0000001F,d3               
          or.l      d3,d0                       
          move.l    d0,d1                       
          jsr       cv_d1L(pc)
          movem.l   (sp)+,qiu.reg
qiu_rts
          rts
x056C
          move.w    #$003C,d2           ; 60
          bsr       x05F4
          move.w    d0,d3                       
          swap      d3                          
          bsr.s     x05F4
          move.w    d0,d3                       
          divu      #$0018,d1           ; 24
          move.l    d1,d2                       
          andi.l    #$0000FFFF,d1               
          move.l    d1,d0                       
          divu      #$0007,d0                   
          swap      d0                          
          divu      #$05B5,d1           ; 1461
          move.w    d1,d2                       
          asl.w     #$02,d2                     
          addi.w    #$07A9,d2           ; 1961
          clr.w     d1                          
          swap      d1                          
          divu      #$016D,d1           ; 365
          moveq     #$00,d4                     
          cmpi.w    #$0004,d1                   
          bne.s     x05B2
          subq.w    #$01,d1                     
          move.w    #$016D,d4           ; 365
x05B2     add.w     d1,d2
          swap      d1                          
          add.w     d4,d1                       
          moveq     #$00,d5                     
          move.w    d2,d4                       
          andi.w    #$0003,d4                   
          bne.s     x05C4
          moveq     #$01,d5                     
x05C4     move.w    d5,d4
          addi.w    #$003A,d4           ; 58
          cmp.w     d4,d1                       
          ble.s     x05D2
          addq.w    #$02,d1                     
          sub.w     d5,d1                       
x05D2     move.w    d1,d5
          addi.w    #$005C,d5           ; 92
          mulu      #$0064,d5           ; 100
          divu      #$0BEF,d5           ; 3055
          move.w    d5,d4                       
          addi.w    #$005C,d1           ; 92
          mulu      #$0BEF,d5           ; 3055
          divu      #$0064,d5           ; 100
          sub.w     d5,d1                       
          subq.w    #$03,d4                     
          rts                                   
x05F4     moveq     #$00,d0
          swap      d1                          
          move.w    d1,d0                       
          divu      d2,d0                       
          swap      d0                          
          move.w    d0,d1                       
          swap      d1                          
          divu      d2,d1                       
          move.w    d1,d0                       
          swap      d1                          
          exg       d0,d1                       
          rts
    end
