; QL ATR Floppy Disk Format   V2.00    1990   Tony Tebby QJUMP   01.11.94 Jo
; DD / HD, nur IBM, kein Atari

        section at

        xdef    at_fdrv
        xdef    fdf_offs

        xref    fq_ckwp
        xref    fq_flsha
        xref    at_flshm
        xref    fq_fint
        xref    fq_wtrack
        xref    fq_wsecl
        xref    fq_rsec
        xref    gu_achp0
        xref    gu_rchp
        xref    cv_qiuhr                ;+
        xref    cv_wfat                 ;+
        xref    at_ftrack               ;+
;-        xref    ibm501E                 ;+ Startsektor 0 ab $1E
        xref    fdl_lp9                 ; Tabelle log->phys 9 sectors ( DD )
        xref.l  fdl_offs                ; Offset zu Tabelle 18 sectors( HD )

        include 'keys_err'
        include 'keys_iod'
;-        include 'keys_hdr'
        include 'keys_karte'       ;+
        include 'keys_cv'          ;+
        include 'keys_sys'
        include 'dd_fq_ddlk'
        include 'dd_fq_QL5A'
        include 'mac_assert'

; rel (a4)
; fdd_map   equ   $0080   ; 5 Sektoren (QL) / fr Sektor 0 IBM
fdf_ql5a  equ   $0280   ; QL5A dummy header 1 Sektor
fdf_rbuf  equ   $0480   ; read buffer 1 Sektor
fdf_null  equ   $0680   ; mit $00 voll bis fdf_trak
fdf_trak  equ   fdd_hdir+$200   ; 26 Sektoren fr 1 komplette Spur HD
;-- fdf.trkl  equ   13*512  ; DD track length = 6656 $1A00
fdf.htrk  equ   26*512  ; HD track length =13312 $3400

; ATRdev DD / HD
; 2880 Sektoren * 3 bytes + rootdir = 17+1 Sektoren map = $2400
; fdd_hfat equ    fdd_map+$2400  ; ATRdev  9 sector fat      IBM
; fdd_hdir equ    fdd_hfat+$1200 ; ATRdev 14 sector root-dir IBM
; fdd.haln equ    fdd_hdir+$1C00 ; = $5280 Lnge ATRdev ATR0 HD

; Gesamt: $0080+$2400+$1200+$200+$3400 = fdf_trak + fdf.htrk = $6C80

;+++
; This formats a Floppy Disk on a QL for IBM 3.5" 720kB or 1.44Mb
;
;       d1  r   good groups
;       d2  r   total groups
;       d6 c  p msw drive number
;       a1 c  p medium name
;       a3 c  p dd linkage block
;       a4      pseudo phys def block  !
;       status return standard
;---
at_fdrv
fdf.reg reg     d3-d5/d7/a0-a2/a4-a5
        movem.l fdf.reg,-(sp)
        moveq   #80,d4                  ; IBM immer 80 Spuren
        move.w  (a1)+,d5                ; Lnge Name
        subq.w  #$05,d5                 ; 'atrx_' weg
        addq.l  #$05,a1
        cmpi.b  #'*',-$01(a1,d5.w)      ; 'name*' ?
;-          beq.s fdf_min1                ; ..ja, DD einseitig
          beq.l fdf_bp                  ; ..ja, ERR_BP
        cmpi.b  #'*',-$02(a1,d5.w)      ; 'name*H', 'name*D', name*S' ?
          bne.s fdf_defd                ; ..nein, 'name', default density
        move.b  -$01(a1,d5.w),d2        ; ..ja, letztes Zeichen ein 'HD' ?
        bsr     den_hd                  ; d1.l = 0 .. 1
          beq.s fdf_min2                ; wenn nicht ok, default nehmen
fdf_defd
        addq.w  #$02,d5                 ; s.fdf_min2/fdf_min1
        move.b  fdd_defd(a3),d1
        ext.w   d1
        bset    #$1F,d4                 ; flag fast format and default density
fdf_min2
        subq.w  #$01,d5                 ; '*H' weg
;fdf_min1
        subq.w  #$01,d5                 ; '*' weg
fdf_flsh
        jsr     fq_flsha                 ; do all pending ops and stop int task
        moveq   #0,d0                    ; flag Laufwerk nicht testen
        jsr     fq_ckwp(pc)              ; write protected (selects and seeks)?
          bne.l fdf_rdon

        move.l  #fdf_trak+fdf.htrk,d0    ; $6C80 Gesamtlnge
        jsr     gu_achp0(pc)
          bne.l fdf_exit                 ; ... oops
        movea.l a0,a4                    ; set base of pseudo definition block

fdf.creg reg    d1-d5
        movem.l fdf.creg,-(sp)
        moveq   #$13,d0         ; MT_RCLK
        trap    #1
        jsr     cv_qiuhr(pc)
        move.l  d1,d7                   ; fr Seriennummer merken
        movem.l (sp)+,fdf.creg

        move    SR,-(a7)            ; nur mit Formatieren beschftigt..
        ori.w   #$0700,SR

        swap    d6
        move.b  d6,iod_dnum(a4)          ; set drive number
        swap    d6

        movea.l fdd_base(a3),a2
        bsr     fq_fint

; Tabelle DD oder HD
        moveq   #fdf_htab-fdf_dtab,d0   ; Lnge einer Datentabelle
        muls    d1,d0                   ; x 0 oder 1 (D oder H)
        lea     fdf_dtab(pc),a2         ; Zeiger auf D-Tabelle
        adda.l  d0,a2                   ; Zeiger auf aktuelle Tabelle

; Mediumname in Root-Dir eintragen (a1)+ -> (a0)+
        lea     fdd_hdir(a4),a0         ; 1. Eintrag in Root-Dir
        tst.w   d5                      ; Lnge Name ohne atrx_
          ble.s fdf_fast                ; nix zum Eintragen
        moveq   #11,d1
        sub.w   d5,d1                   ; >11?
          bge.s fdf_snend               ; ..nein
        moveq   #10,d5                  ; ..yes, take first 11
fdf_snloop
        move.b  (a1)+,(a0)+             ; copy it into root dir
fdf_snend
        dbra    d5,fdf_snloop

        bra.s   fdf_spend
fdf_sploop
        move.b  #' ',(a0)+              ; now pad with spaces
fdf_spend
        subq.w  #1,d1
          bge.s fdf_sploop

        move.b  #8,(a0)+                ; VOL-ID setzen
        move.l  d7,fdd_hdir+$16(a4)     ; IBM-Uhrzeit+Datum eintragen

fdf_fast
        assert  fdd_sctl,fdd_mode-1
        move.w  (a2),fdd_sctl(a4)       ; z.B. 0201 02 fdd_sctl, 01 fdd_mode
        move.w  fdf_bps-fdf_dtab(a2),iod_sctl(a4) ; $0200 = 512 bytes/sector
        moveq   #iod_iolk,d0            ; $18
        add.l   a3,d0
        move.l  d0,iod_drlk(a4)         ; $10   fr dd_fq_slct1

; fast format testen
        tst.l   d4                      ; fast format ?
          bpl.s fdf_fullf               ; ..no
        moveq   #-1,d0
        add.w   d4,d0
        move.b  d0,fdd_trak(a3)         ; letzte Spur
        move.b  D0018-fdf_dtab(a2),fdd_sect(a3) ; flp_strk, letzter Sektor
        move.b  #1,fdd_side(a3)         ; Seite 1
        move.w  fdd_maxr(a3),d0         ; change mode kopieren
        lsr.w   #8,d0                   ; um 1 byte verschieben und lschen
        move.w  d0,fdd_maxr(a3)
        move.l  a1,-(sp)
        move.l  fdd_sadd(a3),d0
        lea     fdf_rbuf(a4),a1         ; 1 sector read buffer
        jsr     fq_rsec(pc)             ; read sector, aber ohne change mode !
        movea.l (sp)+,a1
        move.b  fdd_maxr+1(a3),fdd_maxr(a3) ; change mode zurck
        clr.l   fdd_sadd(a3)            ; bitte jetzt von Anfang an
        tst.l   d0
          beq.s fdf_fullf               ; ok, fast format
        bclr    #$1F,d4                 ; nicht ok, full format
fdf_fullf

; Sektor 0 IBM / QL5A-dummy aufsetzen
fdf_sek0
        lea     fdf_ql5a(a4),a5         ; QL5A dummy map
        lea     fdd_map(a4),a0          ; hier ibm Sektor 0 hinschreiben

; BootSektor DD / HD kopieren
        lea     D0000-fdf_dtab(a2),a1
        moveq   #(fdf_htab-D0000)/2,d0
        bsr.s   fdf_cd0w
;-        lea     ibm501E(pc),a1
        move.l  fdd_ibm0(a3),d0         ; Zeiger auf ibm501E Startsektor
          beq.s fdf_ns0                 ; ..nicht gesetzt
        movea.l d0,a1                   ; Zeiger auf ibm501E Startsektor ok
        move.w  #($200-$001E)/2,d0
        bsr.s   fdf_cd0w
fdf_ns0
        lea     fdd_map(a4),a0
        adda.w  #$0027,a0               ; Zeiger auf Datentrger Seriennummer
        moveq   #3,d0
fdf_snum
        rol.l   #8,d7
        move.b  d7,(a0)+                ; $27..$2A
        dbf     d0,fdf_snum

; FAT vorbereiten
        lea     fdd_hfat(a4),a0
        move.b  D0015-fdf_dtab(a2),(a0)+ ; ID-byte F9 oder F0
        st      (a0)+
        st      (a0)+                   ; FAT: F9FFFF oder F0FFFF
        bra.s   fdf_qlmap
; ------------------------------ Copy d0 words
fdf_cd0w
        bra.s   fdf_cdw
fdf_cdl move.w  (a1)+,(a0)+
fdf_cdw dbf     d0,fdf_cdl
        rts
; ------------------------------
fdf_qlmap
        lea     fdf_free-fdf_dtab(a2),a1
        lea     flp_free(a5),a0
        moveq   #(fdf_loph-fdf_free)/2,d0
        bsr.s   fdf_cd0w
        move.w  (a1),d0
        lea     fdl_lp9(pc),a1
        adda.w  d0,a1
        moveq   #18,d0
        bsr.s   fdf_cd0w
        move.w  fdf_nfat-fdf_dtab(a2),ibm_nfat(a5)
        assert  ibm_file,ibm_fdir+2
        move.l  fdf_fdir-fdf_dtab(a2),ibm_fdir(a5)
        move.w  fdf_allc-fdf_dtab(a2),d7 ; Anzahl Sektoren pro Cluster
        move.w  fdf_scyl-fdf_dtab(a2),d5 ; Anzahl Sektoren pro Zylinder

; now format and check all the tracks

fdf_tr_loop
        lea     fdf_trak(a4),a1         ;+ 26 Sektor buffer
        move.b  #1,fdd_side(a3)         ; side 1
        jsr     at_ftrack(pc)           ;+
          bne.s fdf_tr_bad
        clr.b   fdd_side(a3)            ; side 0
        jsr     at_ftrack(pc)           ;+
          beq.s fdf_tr_eloop            ; gute Spur, ok

fdf_tr_bad
        moveq   #0,d2
        move.b  fdd_trak(a3),d2          ; track-Nr
        mulu    d5,d2                    ; * Anzahl Sektoren/Zylinder
        sub.w   fdf_file-fdf_dtab(a2),d2 ; - erster Sektor Filebereich
        divu    d7,d2                    ; / Anzahl Sektoren pro Gruppe
        tst.w   d2
          ble   fdf_fmtf                 ; Sektoren ohne FAT-Nr immer ganz !!!
        addq.w  #2,d2                    ; + FAT-offset = Cluster-Nr
        swap    d2
        move.w  #$FFF7,d2               ; d2.lsw FAT-Eintrag: defekter Sektor

        move.w  d5,d1                   ; 18 oder 36
        sub.w   d1,flp_good(a5)         ; so viele Sektoren weniger
        divu    d7,d1                   ; / Anzahl Sektoren pro Gruppe
fdf_tr_gloop
        jsr     cv_wfat(pc)             ; FAT schreiben
        swap    d2
        addq.w  #1,d2                   ; nchster Eintrag
        swap    d2
        subq.w  #1,d1
          bgt.s fdf_tr_gloop

fdf_tr_eloop
        addq.b  #1,fdd_trak(a3)          ; move on one track
        cmp.b   fdd_trak(a3),d4          ; end of map?
          bgt.s fdf_tr_loop              ; ... no

; FAT schreiben
        sf      fdd_schk(a3)             ; do not fail please
        moveq   #-1,d0
        move.w  d0,fdd_mup0(a4)         ; $68(a4)
        move.b  d0,fdd_mup2(a4)         ; $6A(a4) 3 Sektoren FAT
        tst.b   fdd_mode(a4)
          beq.s fdf_isdd
        move.b  d0,fdd_mup3(a4)         ; $6B(a4)
        move.l  d0,fdd_mup4(a4)         ; $6C(a4)
        move.b  d0,fdd_mup8(a4)         ; $70(a4) 9 Sektoren FAT
fdf_isdd
        jsr     at_flshm(pc)            ; write FAT sectors
          bne.s fdf_fmtf                ; ... oops

; Rootdir schreiben
        moveq   #0,d5
        move.w  fdf_fdir-fdf_dtab(a2),d5 ; erster Sektor Root-Dir
        move.w  d5,d4                   ; merken
fdf_dloop
        move.l  d5,d0
        divu    d7,d0                   ; / Sektoren pro Cluster
        swap    d0                      ; group / sector
        lea     fdd_hdir(a4),a1
        cmp.w   d4,d5
          beq.s fdf_dir0
        lea     fdf_null(a4),a1
fdf_dir0
        jsr     fq_wsecl(pc)
          bne.s fdf_fmtf
        addq.w  #1,d5
        cmp.w   fdf_file-fdf_dtab(a2),d5
          blt.s fdf_dloop

; Startsektor schreiben
        moveq   #0,d0                   ; Sektor 0
        lea     fdd_map(a4),a1
        jsr     fq_wsecl(pc)
          bne.s fdf_fmtf
fdf_done
        st      fdd_schk(a3)            ; change the drive so next open rereads
        move    (a7)+,SR                ; interrupts frei
        movem.w flp_good(a5),d1/d2      ; set sector counts good/totl
        move.l  a4,a0
        jsr     gu_rchp(pc)
fdf_exit
        movem.l (sp)+,fdf.reg
        rts
fdf_rdon
        moveq   #err.rdo,d0              ; read only
        bra.s   fdf_exit
fdf_fmtf
        moveq   #err.fmtf,d0             ; format failed
        bra.s   fdf_done
fdf_bp
        moveq   #-15,d0                 ; bad parameter
        bra.s   fdf_exit

den_hd
;        move.l  #'EHDS',d0
        move.w  #'HD',d0
        andi.b  #$DF,d2
        moveq   #$00,d1
den_slop
        cmp.b   d2,d0
          beq.s den_ok
        addq.l  #$01,d1
        lsr.l   #$08,d0
          bne.s den_slop
        moveq   #-$0F,d0        ; ERR_BP
        rts
den_ok
        moveq   #0,d0           ; ERR_ok
        rts

; IBM Double Density, 9 sectors, double side
fdf_dtab  dc.w  $0200           ; fdd_sctl 02, fdd_mode 00
fdf_bps   dc.w  $0200           ; bytes per sector
fdf_free
         dc.w   $05A0   ; word  free sectors
         dc.w   $05A0   ; word  good sectors
         dc.w   $05A0   ; word  total sectors
fdf_strk dc.w   $0009   ; word  sectors per track
fdf_scyl dc.w   $0012   ; word  sectors per cylinders
         dc.w   $0050   ; word  number of tracks (cylinders)
fdf_allc dc.w   $0002   ; word  sectors per group
         dc.l   $0000000 ;long  current end of directory (block/byte format)
         dc.w   $0000   ; word  sector offset
fdf_loph dc.w   0       ; word  offset zu fdl_lp9(pc)
fdf_nfat dc.w   3       ; Anzahl Sektoren pro FAT
fdf_fdir dc.w   7       ; erster Sektor Rootdir
fdf_file dc.w   14      ; erster Sektor Filebereich
fdf_offs equ    fdf_strk-fdf_dtab

D0000   dc.b    $EB,$3C,$90     ; jump
D0003   dc.b    'MSDOS5.0'      ; Name
D000B   dc.b    $00,$02         ; Anzahl Bytes pro Sektor
D000D   dc.b    $02             ; Anzahl Sektoren pro Cluster
D000E   dc.w    $0100           ; Anzahl reservierte Sektoren
D0010   dc.b    $02             ; Anzahl FAT's
D0011   dc.b    $70,$00         ; Anzahl Eintrge ins Root-Dir
D0013   dc.b    $A0,$05         ; Gesamtzahl der Sektoren
D0015   dc.b    $F9             ; ID-byte
D0016   dc.w    $0300           ; Anzahl Sektoren fr eine FAT
D0018   dc.w    $0900           ; Anzahl der Sektoren pro Spur
D001A   dc.w    $0200           ; Anzahl der Kpfe (Seiten)
D001C   dc.w    $0000           ; Anzahl verborgene Sektoren

; IBM High Density, 18 sectors, double side
fdf_htab  dc.w  $0201           ; fdd_sctl 02, fdd_mode 01
          dc.w  $0200           ; bytes per sector

         dc.w   $0B40   ; word  free sectors
         dc.w   $0B40   ; word  good sectors
         dc.w   $0B40   ; word  total sectors
         dc.w   $0012   ; word  sectors per track
         dc.w   $0024   ; word  sectors per cylinders
         dc.w   $0050   ; word  number of tracks (cylinders)
         dc.w   $0001   ; word  sectors per group
         dc.l   $0000000 ;long  current end of directory (block/byte format)
         dc.w   $0000   ; word  sector offset
         dc.w  fdl_offs ; word  offset zu fdl_lp9(pc)
         dc.w   9       ; Anzahl Sektoren pro FAT
         dc.w   19      ; erster Sektor Rootdir
         dc.w   33      ; erster Sektor Filebereich

H0000   dc.b    $EB,$3C,$90     ; jump
H0003   dc.b    'MSDOS5.0'      ; Name
H000B   dc.b    $00,$02         ; Anzahl Bytes pro Sektor
H000D   dc.b    $01             ; Anzahl Sektoren pro Cluster
H000E   dc.w    $0100           ; Anzahl reservierte Sektoren
H0010   dc.b    $02             ; Anzahl FAT's
H0011   dc.b    $E0,$00         ; Anzahl Eintrge ins Root-Dir
H0013   dc.b    $40,$0B         ; Gesamtzahl der Sektoren
H0015   dc.b    $F0             ; ID-byte
H0016   dc.w    $0900           ; Anzahl Sektoren fr eine FAT
H0018   dc.w    $1200           ; Anzahl der Sektoren pro Spur
H001A   dc.w    $0200           ; Anzahl der Kpfe (Seiten)
H001C   dc.w    $0000           ; Anzahl verborgene Sektoren

    end

