; QL check write protect                1991 Jo

        section fq

        xdef    fq_ckwp

        xref    fq_sss
        xref    fq_cmdwr
        xref    fq_fint
        xref    fq_slct
        xref    fq_read1s
;        xref    fq_ckrdy
        xref    wait80us

        include 'flp1_keys_karte'
        include 'flp1_keys_err'
        include 'flp1_dd_fq_ddlk'

;+++
; Check write protect, selectes and seeks to track 0
;
;       all registers preserved
;
;       a3 c  p  ddd linkage block
;-nu       d0.l  r  0 ok, ERR_FE (laufwerk)
;       status 0 OK, NZ write protected
;
;---
fq_ckwp
fcw.reg reg     d1/a2
        movem.l fcw.reg,-(sp)
        move    sr,-(sp)
        ori.w   #$0700,sr
;        st      fdd_dma(a3)              ; WD1772 belegt
        movea.l fdd_base(a3),a2
;        move.l  d0,d1                   ; flag = 0 laufwerk leer nicht testen
        move.l  #$000000ff,fdd_sadd(a3)  ; track zero, side zero, silly sector
        moveq   #0,d0                    ; no verify
        jsr     fq_sss(pc)

;        tst.l   d1
;          beq.s fcw_nlw
;        jsr     fq_ckrdy(pc)             ; testen, ob Diskette im Laufwerk
;          bne.s fcw_err
;fcw_nlw
        moveq   #fdc.wsec,d0             ; write sector
        jsr     fq_cmdwr(pc)

        moveq   #2,d0                    ; wait 2*80 us
        jsr     wait80us(pc)

        moveq   #fds.roly,d1             ; ... to check write protect bit
        and.b   fdc_stat(a2),d1
        jsr     fq_fint(pc)
        moveq   #0,d0
;fcw_exit
;        sf      fdd_dma(a3)
        move    (sp)+,sr
        tst.b   d1                      ; =0 read/write, =$40 read only
        movem.l (sp)+,fcw.reg
        rts
;fcw_err
;        jsr     fq_fint(pc)
;        moveq   #0,d1
;        moveq   #-$10,d0        ; ERR_FE
;        bra.s   fcw_exit
        end
