; Floppy Disk Mark Updated    V1.00    1988   Tony Tebby QJUMP   Jo

        section fq

        xdef    fq_upbf

        include 'flp1_keys_chn'
        include 'flp1_keys_sbt'
        include 'flp1_dd_fq_ddlk'
;+++
; This marks the buffer (actually a slave block) updated
;
;       a0 c  p channel block
;       a3 c  p pointer to linkage block
;       a4 c  p pointer to physical definition
;
;       status return arbitrary
;---
fq_upbf
        move.l  a1,-(sp)
        move.l  chn_csb(a0),a1           ; current slave block
        bset    #sbt..wrq,sbt_stat(a1)   ; ... but written
        cmp.l   fdd_slvl(a3),a1          ; below range?
        bhs.s   fdu_h
        move.l  a1,fdd_slvl(a3)          ; set low range
fdu_h
        cmp.l   fdd_slvh(a3),a1          ; above range?
        bls.s   fdu_exit
        move.l  a1,fdd_slvh(a3)          ; set high range
fdu_exit
        st      fdd_mup0(a4)             ; update map !
        move.b  #fdd.at17,fdd_actm(a3)   ; count..
        st      fdd_freq(a3)             ; ..until flush
        move.l  (sp)+,a1
        rts
        end
