; Ram Disk Locate Buffer                          Jo 1991

          section   rd

          xdef      rd_lcbf
          xdef      rd_albf
          xdef      rd_alfs
          xdef      rd_alfs1
          xdef      rd_allc
          xdef      rd_allc1

          xref      gu_achpp            ; alocate common heap for Basic
;+++
; Ram Disk Locate Buffer, Ram Disk Allocate Buffer
;
;       d3  r   (word) bytes left in buffer
;       d4  r   block/byte
;       d5 c  p file position
;       d6 c  p drive / file number
;       a0 c  p channel block
;       a2  r   pointer to buffer
;       a3 c  p pointer to linkage block
;       a4 c  p pointer to physical definition block
;       a5 c  p pointer to map
;
;       status return standard
;---
rd_lcbf
rd_albf
L1346     move.l    d5,d4
          lsl.l     #$07,d4
          lsr.w     #$07,d4
          swap      d4
          move.l    $0028(a0),d0
            beq.s   L1364
          movea.l   d0,a2
          cmp.w     $000C(a2),d6
            bne.s   L1364
          cmp.w     $000E(a2),d4
            beq.s   L139E
            bhi.s   L1386
L1364     movea.l   a5,a2
          moveq     #$00,d0
          move.w    d6,d0
L136A     subi.w    #$0080,d0
            bcs.s   L1374
          movea.l   (a2),a2
          bra.s     L136A
L1374     addi.w    #$0080,d0
          lsl.l     #$02,d0
          move.l    $10(a2,d0.l),d0
L137E     movea.l   d0,a2
          cmp.w     $000E(a2),d4
            beq.s   L139A
L1386     move.l    (a2),d0
            bne.s   L137E
          bsr.s     rd_allc
            bne.s   L13AE
          move.l    d0,(a2)
          movea.l   d0,a2
          move.w    d6,$000C(a2)
          move.w    d4,$000E(a2)
L139A     move.l    a2,$0028(a0)
L139E     swap      d4
          lea       $10(a2,d4.w),a2
          move.l    #$00000200,d3
          sub.w     d4,d3
          moveq     #$00,d0
L13AE     rts

;+++
; Ram Disk Allocate first sector
;---
rd_alfs
L13B0     tst.w     d1
            bne.s   L13F6
rd_alfs1
L13B4     move.l    a5,d0
          moveq     #$00,d1
L13B8     movea.l   d0,a2
          move.w    #$0080,d0
          add.w     d0,d1
          subq.w    #$01,d0
          lea       $0010(a2),a2
L13C6     tst.l     (a2)+
          dbeq      d0,L13C6
            beq.s   L13E4
          move.l    -$0210(a2),d0
            bne.s   L13B8
          bsr.s     rd_allc
            bne.s   L13F8
          move.l    d0,-$0210(a2)
          movea.l   d0,a2
          moveq     #-$01,d0            ; ERR_NC
          lea       $0014(a2),a2
L13E4     sub.w     d0,d1
          subq.w    #$01,d1
          subq.l    #$04,a2
          bsr.s     rd_allc
            bne.s   L13F8
          move.l    d0,(a2)
          movea.l   d0,a2
          move.w    d1,$000C(a2)
L13F6     moveq     #$00,d0
L13F8     rts

;+++
; rd_allc ???
;---
rd_allc
L13FA     tst.b     $000B(a5)
            bne.s   L1412
rd_allc1
L1400     move.l    a0,-(a7)
          move.l    #$00000210,d0
          jsr       gu_achpp(pc)        ;L6C14(PC)
            bne.s   L1430
          exg       d0,a0
          bra.s     L142C
L1412
          move.l    a0,-(a7)
          move.l    -$0008(a5),d0
            beq.s   L1430
          movea.l   d0,a0
          move.l    (a0),-$0008(a5)
          subq.w    #$01,-$0004(a5)
          clr.l     (a0)+
          clr.l     (a0)+
          clr.l     (a0)+
          clr.l     (a0)+
L142C
          movea.l   (a7)+,a0
          rts
L1430
          moveq     #-$0B,d0            ; ERR_DF
          bra.s     L142C
       end
