; ATR Make Directory    V2.02     1989  Tony Tebby   QJUMP  / Jo 30.12.91
; nicht fr FLP

        section ioi

        xdef    ioi_mkdr

        xref    gu_achpp
        xref    gu_rchp
        xref    iou_smlw
        xref    iou_sde0
        xref    iou_fde0

        include 'keys_chn'
        include 'keys_hdr'
        include 'keys_err'
        include 'keys_sbt'
        include 'keys_qdos_ioa'
        include 'dd_fq_ddlk'
        include 'dd_fq_ql5a'

        include 'mac_assert'
;+++
; Make Directory
;
;       d1-d7 / a0-a4 / a6 all preserved
;       d6 c  p drive / file ID
;       a0 c  p channel base address
;       a3 c  p linkage block address
;       a4 c  p phys.def.block
;
;       status return standard
;---
ioi_mkdr
reg.mkdr reg    d1-d7/a1
reg.chan reg    a0/a4
frame    equ    4
stk_wrk  equ    $00                     ; = heap
stk_chan equ    frame                   ; = a0
stk_defb equ    frame+$04               ; = a4
        movem.l reg.mkdr,-(sp)
        movem.l reg.chan,-(sp)

;-        assert  fdd.hold,-1
;-        st      fdd_actm(a3)            ;*** stop poll

;        move.l  #chn_spr+hdr.len*2,d0    ; allocate some working space = $1E0
;        moveq   #hdr.len,d0             ; = $40
;        add.w   d0,d0                   ; = $80 fr 2 header
        move.l  #hdr.len*3,d0           ; = $C0  fr 3 header
        jsr     gu_achpp
          bne.l imd_ex0
        move.l  a0,-(sp)                 ; keep heap address
        move.l  a0,a1                    ; (a1) heap

        moveq   #$13,d0         ; MT_RCLCK
        trap    #1
        move.l  d1,d2                   ; d2.l QL-Uhrzeit/Datum

        move.l  stk_chan(sp),a0          ; restore channel
        st      hdr_type(a1)             ; set header type
        lea     hdr_name(a1),a1
        lea     chn_name(a0),a0
        move.w  (a0)+,d0
        cmp.b   #'_',-1(a0,d0.w)         ; ends in underscore?
          bne.s imd_snam
        subq.w  #1,d0                    ; ... yes, strip it
          beq.l imd_inam                 ; "_" , bad parameter
imd_snam
        move.w  d0,(a1)+
        move.w  d0,d1
imd_name
        move.b  (a0)+,(a1)+              ; copy chn_name(a0) -> hdr_name(a1)
        subq.w  #1,d0
        bgt.s   imd_name

        move.l  stk_wrk(sp),a1           ; (a1) heap
        move.l  stk_chan(sp),a0          ; (a0) channel

        move.w  fdd_path(a4),d0             ;+
        sub.w   d0,d1                       ;+ QL-Name - Pfad
        cmpi.w  #8,d1                       ;+ lnger als 8 bytes ?
          bgt   imd_inam                    ;+ ..zu lang
        cmpi.w  #1,d6                       ;+ root dir ?
          bgt.s imd_sset                    ;+
        moveq   #0,d0                       ;+ Pfadlnge = 0
imd_sset
        move.w  d0,hdr_path(a1)             ;+ Lnge Pfadname
        move.w  fdd_clus(a4),hdr_clus(a1)   ;+ 1.Cluster
        move.b  #$10,hdr_attr(a1)           ;+ IBM Attribut subdir
;        bset    #hdr..att,hdr_dset(a1)      ;+ flag Attribut gesetzt
;        bset    #hdr..ext,hdr_dset(a1)      ;+ flag Extention gesetzt (=0)
        move.b  #$03,hdr_dset(a1)           ;+ flags s.o.
        move.w  chn_flid(a0),hdr_flid(a1) ; set ID
        move.l  d2,hdr_date(a1)
        moveq   #hdr.len,d7
        jsr     iou_sde0(pc)              ; set directory entry
          bne   imd_inam                  ; nanu ???

; Cluster fr IBM .. - File suchen
        move.w  chn_sdid(a0),d0
        cmpi.w  #1,d0                    ; root-dir ?
          ble.s imd_root                 ; ..ja
        movea.l stk_wrk(sp),a1
        lea     hdr.len*2(a1),a1
        moveq   #hdr.len,d7
        move.l  chn_sdps(a0),d3
        clr.l   chn_sdps(a0)            ; position of IBM . - File  = 0
        jsr     iou_fde0(pc)
          bne   imd_inam                 ; oops ???
        move.l  d3,chn_sdps(a0)
imd_root
        move.b  #ioa.kdir,chn_accs(a0)  ; ab jetzt accsess = kdir

; IBM . - File
        movea.l stk_wrk(sp),a1           ; get working block (a1) heap
        moveq   #hdr.len,d7
        move.l  d7,hdr_flen(a1)
        move.w  hdr_name(a1),d0         ; Lnge subdir-name ohne '_'
        move.b  #'_',hdr_name+2(a1,d0.w)
        move.w  d0,hdr_path(a1)         ; = Pfadlnge ohne '_'
        move.b  #'.',hdr_name+3(a1,d0.w) ; IBM . - File
        addq.w  #2,hdr_name(a1)
        clr.w   hdr_flid(a1)
        move.l  d2,hdr_date(a1)
        moveq   #0,d5                   ; position at start of file
        jsr     iou_smlw(pc)            ; set multible bytes and wait

; IBM .. - File
        moveq   #hdr.len,d7
        movea.l stk_wrk(sp),a1
        move.w  hdr_name(a1),d0
        move.b  #'.',hdr_name+2(a1,d0.w)
        addq.w  #1,hdr_name(a1)
        move.w  hdr.len*2+hdr_clus(a1),hdr_clus(a1)
        jsr     iou_smlw(pc)

; QL subdir Endflag $7F
        moveq   #4,d3                   ; 5 Eintrge vorbelegen
imd_fill
        moveq   #hdr.len,d7
        movea.l stk_wrk(sp),a1
        adda.l  d7,a1
        move.b  #$7F,(a1)
        jsr     iou_smlw(pc)
        dbf     d3,imd_fill
; QL Anzeige vorbereiten
        lea     fdd_map(a4),a1           ; QL map
        move.l  #$400,d0                 ; 2 * $200 bytes
        mulu    flp_allc(a1),d0          ; DD 2, HD 1
        move.l  d0,chn_feof(a0)          ; 2048 bytes bei DD, 1024 bytes bei HD
        or.b    #1<<chn..dst+1<<chn..vst,chn_usef(a0) ; set usage flags
        movea.l chn_csb(a0),a1           ; aktuellen Slaveblock..
        bset    #7,sbt_phys(a1)          ; ..als subdir kennzeichnen
        st      chn_updt(a0)             ; updated

        bra.s   imd_ok
imd_inam
        moveq   #err.inam,d0
        bra.s   imd_exit
imd_ok
        moveq   #0,d0
imd_exit
        move.l  (sp)+,a0                 ; throw away the work space
        jsr     gu_rchp
imd_ex0
;-        move.b  #fdd.at17,fdd_actm(a3)   ;*** start poll
;-        st      fdd_freq(a3)             ; ..and flush
;-        tst.l   d0
        movem.l (sp)+,reg.chan
        movem.l (sp)+,reg.mkdr
        rts
   end
