; Eprom Header Sandy V2.18                              04.11.94 Jo
; FLP / ATR / Basic  DD / HD

          section   main

          xdef      base

          xref.l    rom.vers
          xref.l    datum

          xref      fq_init   ; Floppy Disk
          xref      par_init  ; Centronics
          xref      rd_init   ; Ram Disk
          xref      at_init   ; ATRdev
          xref      basic_ini ; Basic-Befehle + ATRconv-Liste

;          include   'dd_fq_ddlk'
;+++
; ROM Header Sandy
;---
base
;-          bra.s     ini       ; CALL - Version fr TEST
;-          nop
          dc.l      $4AFB0001
          dc.w      0
          dc.w      ini-base
          dc.w      $24
          dc.b      'Sandy HD Disk Controller V'
          dc.l      rom.vers
          dc.b      ' 94Jo',$0A
          dc.l      datum
ini
reg.rom   reg       a0/a3
          movem.l   reg.rom,-(sp)

          bsr       fq_init
          bsr       par_init            ; Achtung: par_init NACH fq_init !!!
          bsr       rd_init
          bsr       at_init
          bsr       basic_ini

; TK2 - Defaults, falls noch nicht gesetzt
          moveq     #$00,d0             ; MT_INF
          trap      #$01                ; SYS_BASE $28000 -> a0
          movea.l   a0,a5
          tst.l     $AC(a5)             ; SYS_PROGD
            bne.s   tk2defset
          moveq     #$18,d0             ; MT_ALCHP
          moveq     #$6C,d1
          moveq     #$00,d2
          trap      #$01
          movea.l   a0,a4
          lea       $00AC(a5),a0        ; SYS_PRGD
          move.l    #$0005464C,d2       ; 0005+'FLP1_ '
          move.l    #'P1_ ',d1
          moveq     #$20,d0             ; Platz pro Eintrag
          move.l    a4,(a0)+
          move.l    d2,(a4)+
          move.l    d1,(a4)
          adda.w    d0,a4           ; SYS_DATAD
          move.l    a4,(a0)+
          move.l    d2,(a4)+
          move.l    d1,(a4)
          adda.w    d0,a4           ; SYS_DESTD
          move.l    a4,(a0)+
          move.w    #$0003,(a4)+
          move.l    #'SER ',(a4)        ; 0003+'SER '
tk2defset
          movem.l   (sp)+,reg.rom
          moveq     #0,d0
          rts

     end
