; Drucker-Schnittstelle Centronics PAR                      Jo 1991
; mit Poll-Routine
; fdd_cont(a3) aktuelle Einstellung command-reg $3FC4(pc)

          section   par

          xdef      par_init

;-          xref      fq_hardio

          include   'flp1_keys_karte_sandy'
          include   'flp1_dd_fq_ddlk'
          include   'flp1_mac_assert'

          assert    fdd_par+$40,fdd_end ; = $340
par_init
          lea       fdd_par(a3),a0      ; $300(a3) bis $340(a3) PAR-DDD
P1444     lea       par_xint(PC),a2     ; XINT_R
          move.l    a2,$0004(a0)
          lea       par_poll(pc),a2     ; POLL_R (neu)
          move.l    a2,$000C(a0)
          lea       par_schd(PC),a2     ; SCHD_R
          move.l    a2,$0014(a0)
          lea       $001C(a0),a1
          lea       par_io(PC),a2       ; IO_R
          move.l    a2,(a1)+
          lea       par_open(PC),a2     ; OPEN_R
          move.l    a2,(a1)+
          lea       par_cl(PC),a2       ; CLOSE_R
          move.l    a2,(a1)+
          lea       par_erpb(PC),a2     ; TEST Pending Input (ERR_BP)
          move.l    a2,(a1)+
          move.l    a2,(a1)+            ; FETCH Byte (ERR_BP)
          lea       par_send(PC),a2     ; SEND Byte
          move.l    a2,(a1)+
          move.w    #$4E75,(a1)         ; rts
          tas       par_qlen+3(a0)      ; setzt $003F default $80 bytes puffer
          moveq     #$1A,d0             ; MT_LXINT
          trap      #$01
          addq.l    #8,a0
          moveq     #$1C,d0             ; MT_LPOLL (neu)
          trap      #1
          addq.l    #8,a0
          moveq     #$1E,d0             ; MT_LSCHD
          trap      #$01
          addq.l    #$08,a0
          moveq     #$20,d0             ; MT_LIOD
          trap      #$01
          rts

; Externe Interrupt-Routine par
par_xint
;-          bsr       fq_hardio           ; fdc_adr(pc)->a2
          movea.l   fdd_base-fdd_par(a3),a2
          movea.l   a2,a4               ; a4 z.B. $000C3FC0
          movea.l   a3,a1               ; a3 linkadresse retten wegen IO_QOUT
          move.b    fdd_cont-fdd_par(a1),d2 ; aktuellen Wert Steuerbyte holen
          move.l    par_queu(a1),d0     ; Basisadresse PIPE
            beq.s   P1528               ; ..keine da, PAR aus
          movea.l   d0,a2               ; ..ok
          btst      #fdc.busy,fdc_busy(a4) ; PAR busy ? bit 0, $3FCC
            bne.s   P1520               ; ..gesetzt, not busy
          movea.w   $000000E2,a3        ; IO_QOUT
          jsr       (a3)                ; ein byte aus pipe holen -> d1
          addq.l    #$01,d0
            beq.s   P1528               ; ..ERR_NC
            bgt.s   P1506               ; ..ok

          st        par_clos(a1)        ; ..ERR_EOF oder ERR_ ...
          tst.b     -$0001(a2)          ; Flag FF schicken ?
            beq.s   P1528               ; ..nein
          sf        -$0001(a2)
          moveq     #$0C,d1             ; FF Form Feed
          bsr.s     P1514               ; ..schicken
          bra.s     P1528
P1506
          tst.b     -$0002(a2)          ; Flag LF -> CR ?
            beq.s   P1514               ; ..nein
          cmpi.b    #$0A,d1             ; LF Line Feed
            bne.s   P1514
          moveq     #$0D,d1             ; LF -> CR Carr. Return schicken
P1514
          move.b    d1,fdc_par(a4)      ; PAR-Byte auf Centronics
          bset      #fdc.ds,d2          ; /DS auf L
          bset      #fdc.par,d2         ; PAR ein
          bsr.s     P152C               ; % x11x xxxx setzen
          moveq     #8,d0
par_dsl   subq.w    #1,d0               ; damit /DS nicht zu kurz ist...
            bgt.s   par_dsl
P1520
          bclr      #fdc.ds,d2          ; /DS auf H
          bset      #fdc.par,d2         ; PAR ein
          bra.s     P152C               ; % x10x xxxx setzen
P1528
          andi.b     #$9F,d2            ; % x00x xxxx setzen, PAR ausschalten
P152C
          move.b    d2,fdd_cont-fdd_par(a1) ; aktueller Wert controll-register
          move.b    d2,fdc_cont(a4)      ; controll-register $3FC4 setzen
          moveq     #0,d0
          rts
par_erpb
          moveq     #-$0F,d0            ; ERR_BP
P1536     rts

; POLL-Routine par
par_poll
          move.b    fdd_cont-fdd_par(a3),d2 ; Steuerbyte
          btst      #fdc.par,d2
            beq.s   ppl_rts             ; PAR aus
;-          bsr       fq_hardio           ; io_adr -> a2
          movea.l   fdd_base-fdd_par(a3),a2
          move.b    d2,fdc_cont(a2)     ; Steuerbyte -> $3FC4
ppl_rts   rts


; SCHD-Routine par
par_schd
          tst.b     par_clos(a3)        ; Flag ERR_EOF, Kanal schlieen
            beq.s   P1536               ; ..noch nicht
          sf        par_clos(a3)        ; Flag ok, geschlossen
          move.l    par_queu(a3),d0     ; Basisadresse Pipe PAR
            beq.s   P1536
          movea.l   d0,a0
          move.l    (a0),d0             ; nchste Pipe, pending File
          andi.l    #$00FFFFFF,d0
          move.l    d0,par_queu(a3)
          move.b    fdd_cont-fdd_par(a3),d0
          bclr      #fdc.ds,d0          ; /DS auf H
          bset      #fdc.par,d0         ; % x10x xxxx setzen, PAR ein
          move.b    d0,fdd_cont-fdd_par(a3)
          suba.w    #$001A,a0
          movea.w   $000000C2,a2        ; MM_RECHP freigeben nach close
          jmp       (a2)

; IO_Routine PAR
par_io
          cmpi.b    #$07,d0             ; File-IO..
            bhi.s   par_erpb            ; ..gibt's hier nicht
          movea.l   a3,a5               ; linkadresse a3 retten wegen IO_SERIO
          bsr.s     P14A8               ; ( IO_SERIO )
          move.b    fdd_cont-fdd_par(a5),d3
          bclr      #fdc.ds,d3          ; /DS auf H
          bset      #fdc.par,d3         ; % x10x xxxx setzen, PAR ein
          move.b    d3,fdd_cont-fdd_par(a5)
          rts
P14A8
          pea       $0028(a3)
          movea.w   $000000EA,a2        ; IO_SERIO
          jmp       (a2)

; OPEN_Routine PAR
par_open
          suba.w    #$0010,a7
          movea.l   a3,a4               ; linkadresse a3 retten wegen IO_NAME
          movea.l   a7,a3               ; $10 bytes Puffer
          movea.w   $00000122,a2        ; IO_NAME
          jsr       (a2)
          bra.s     P1DA6               ; ERR_NF
          bra.s     P1DA2               ; ERR_BN
          bra.s     P1DE4               ; ERR_ok
          dc.w      $0003
          dc.b      'PAR',$00
          dc.w      $0004,$0001         ; 4 Parameter
          dc.b      'C',$00             ; LF -> CR umwandeln
          dc.w      $0001
          dc.b      'F',$00             ; nach close FF schicken
          dc.b      ' _'
          dc.w      $0000,$0001         ; Buffer, default in bytes (0)
          dc.b      'K',$00             ; ..in Kbytes

P1DA2     bra       P1E46               ; -> addq.l a7, rts

P1DA6     tst.b     par_usef(a4)        ; Flag von PAR_USE: PAR = 0, SER = -1
            beq.s   P1DA2
          movea.w   $00000122,a2        ; IO_NAME
          jsr       (a2)
          bra.s     P1DA2               ; ERR_NF
          bra.s     P1DA2               ; ERR_BN
          bra.s     P1DE2               ; ERR_ok
          dc.w      $0003
          dc.b      'SER',$00
          dc.w      $0008,$FFFF         ; 8 Parameter
          dc.w      $0000,$0004
          dc.b      'OEMS'
          dc.w      $0002
          dc.b      'IH'
          dc.w      $0002
          dc.b      'RZ'
          dc.w      $0001
          dc.b      'C',$00
          dc.w      $0001
          dc.b      'F',$00
          dc.b      ' _'
          dc.w      $0000,$0001
          dc.b      'K',$00

P1DE2     addq.l    #$08,a3             ; 8 Parameter-bytes ignorieren
P1DE4     lea       par_queu(a4),a5
          move.l    (a5),d0
            beq.s   P1DFA
P1DEC     movea.l   d0,a5
          move.l    (a5),d0
            bge.s   P1E50               ; -> ERR_IU
          andi.l    #$00FFFFFF,d0
            bne.s   P1DEC
P1DFA     tst.w     (a3)+
          sne       d7
          lsl.w     #$08,d7
          tst.w     (a3)+
          sne       d7
          moveq     #$00,d4
          move.w    (a3)+,d4
            ble.s   P1E16
          tst.w     (a3)+               ; Puffer in Kbytes ?
            beq.s   P1E12               ; ..nein, in bytes
          swap      d4
          lsr.l     #$06,d4             ; x 1024
P1E12     move.l    d4,par_qlen(a4)     ; Puffer in bytes
P1E16     move.l    par_qlen(a4),d4
          addq.l    #$02,d4             ; 2 bytes mehr (128+2)
          moveq     #$2A,d1             ; + 42
          add.l     d4,d1
          movea.w   $000000C0,a2        ; MM_ALCHP
          jsr       (a2)
            bne.s   P1E46               ; au weia !
          move.w    d7,$0018(a0)
          lea       $001A(a0),a2
          lea       $10(a2,d4.l),a1
          movea.l   a2,a3               ; Pipe aufsetzen
          clr.l     (a3)+
          move.l    a1,(a3)+
          subq.l    #$02,a1
          move.l    a1,(a3)+
          move.l    a1,(a3)
          move.l    a2,d6
          or.l      (a5),d6
          move.l    d6,(a5)
P1E46     adda.w    #$0010,a7
          rts
;          moveq     #-$0F,d0            ; ERR_BP Label ?
;          bra.s     P1E46
P1E50     moveq     #-$09,d0            ; ERR_IU
          bra.s     P1E46

; CLOSE_Routine PAR
par_cl
          lea       $001A(a0),a2
          tas       (a2)                ; Flag Channel close
;          tas       $003E(a3)           ; wozu ?
          bset      #fdc.par,fdd_cont-fdd_par(a3) ; Flag PAR noch aktiv
          moveq     #$00,d0
          rts

; SEND Byte PAR
par_send
          lea       $001A(a0),a2
;          bra       P1E62               ; -> TRA
; TRA-Liste
P1E62     tst.b     $0144(a6)           ; TRA 1 ?
            beq.s   P1EAC               ; ..nein, keine Liste nehmen
          movea.l   $0146(a6),a1
          adda.w    $0002(a1),a1
          moveq     #$00,d3
          move.b    d1,d3
            beq.s   P1EAC
          move.b    $00(a1,d3.w),d1
            bne.s   P1EAC
          movea.w   $000000DE,a3        ; IO_QTEST
          jsr       (a3)
          moveq     #-$01,d0            ; ERR_NC
          subq.l    #$03,d2
            blt.s   P1EAE
          movea.l   $0146(a6),a1
          adda.w    $0004(a1),a1
          move.b    (a1)+,d1
          bra.s     P1E9C
P1E94     cmp.b     (a1)+,d3
            beq.s   P1EA2
          addq.l    #$03,a1
          subq.b    #$01,d1
P1E9C       bne.s   P1E94
          moveq     #$20,d1
          bra.s     P1EAC
P1EA2     move.b    (a1)+,d1
          bsr.s     P1EB0
          move.b    (a1)+,d1
          bsr.s     P1EB0
          move.b    (a1)+,d1
P1EAC     bsr.s     P1EB0
P1EAE     rts
P1EB0     movea.w   $000000E0,a3        ; IO_QIN
          jmp       (a3)

          end
