; Basic-befehle Floppy, Ram und Par               28.10.94  Jo
; Steprate 2,3,6 ms
; FLP_PREC, FLP_DENSITY neu
; ATRdev wird immer eingebunden.
; bas-code kann irgendwo im Speicher stehen, zum CALLen

          section bas

          xdef      basic_ini
          xdef      iou_use
          xdef      iou_flnk

          xref      ut_gxin1
          xref      ut_gxin
          xref      ut_gxnm1
          xref      id_flag

          include   'dd_fq_ddlk'
          include   'keys_karte'
          include   'keys_cv'

; BASIC einbinden
basic_ini
        lea     defproc(pc),a1
basic_ini1
        movea.w $110,a2   ; BP_INIT
        jsr       (a2)

; ATRconv - Liste und ibm0 anmelden
atr_liste
        bsr     atr_flnk                ; Link ATR0 -> a0
          bne.s bas_rts
        lea     id_flag(pc),a1          ; Zeiger auf id_flag
        cmpi.l  #'qiiq',(a1)            ; ok?
          bne.s bas_rts
        move.l  a1,fdd_cadr-$18(a0)     ; Zeiger auf bersetzungslisten
        adda.w  cv_is0(a1),a1           ; Zeiger auf ibm501E
        move.l  a1,fdd_ibm0-$18(a0)     ; in ATR0 ddd eintragen
bas_rts
        moveq   #0,d0
        rts

;         Basic - Procedure 'ATR_DEV'
;-atrdev0
;-          bsr       at_init
;-          lea       atrdefp(pc),a1
;-          bra.s     basic_ini1

defproc
          dc.w      13 ;-10
          dc.w      ramuse-*
          dc.b      7,'RAM_USE'
          dc.w      flpuse-*
          dc.b      7,'FLP_USE'
          dc.w      paruse-*
          dc.b      7,'PAR_USE'
          dc.w      flptrack-*
          dc.b      9,'FLP_TRACK'
          dc.w      flpstep-*
          dc.b      8,'FLP_STEP',0
          dc.w      flpdens-*
          dc.b      11,'FLP_DENSITY'
          dc.w      flpstart-*
          dc.b      9,'FLP_START'
          dc.w      flpsec-*
          dc.b      7,'FLP_SEC'
          dc.w      flpprec-*
          dc.b      8,'FLP_PREC',0
;-          dc.w      atrdev0-*
;-          dc.b      7,'ATR_DEV'
;-          dc.w      0,0,0
;-atrdefp
;-          dc.w      3
          dc.w      atrdev1-*
          dc.b      7,'ATR_DEV'
          dc.w      atrconv-*
          dc.b      8,'ATR_CONV',0
          dc.w      atruse-*
          dc.b      7,'ATR_USE'
          dc.w      0,0,0

;+++
; Basic-Erweiterungen  FLP, ATR, PAR, RAM
;---

;         BASIC - Procedure   'RAM_USE'
ramuse    move.l    #'RAM0',d7
          jmp       iou_use(PC)


;         BASIC - Procedure   'FLP_USE'
flpuse    move.l    #'FLP0',d7
          jmp       iou_use(PC)


;         BASIC - Procedure   'PAR_USE'
paruse
          move.l    #'FLP0',d7          ; zum Suchen
          move.l    #'PAR0',d6          ; reset PAR_USE annehmen
          cmpa.l    a3,a5               ; Parameter ?
            beq.s   pu_reset            ; ..nein, keiner
          jsr       ut_gxnm1(pc)        ; get 1 string
            bne.s   pu_rts              ; ..nix
          subq.w    #$03,$00(a6,a1.l)   ; string 3 bytes lang ?
            bne     iou_ipar            ; ..nein, ERR_BP
          move.l    $02(a6,a1.l),d6     ; neuer Name -> d6.l
          andi.l    #$5F5F5F00,d6       ; ..in gro
          addi.b    #'0',d6             ; ..mit '0' am Ende
pu_reset
          jsr       iou_flnk(pc)        ; nach d7.l = 'FLP0' suchen
            bne.s   pu_rts              ; ..nicht gefunden
          adda.w    #fdd_par-$0018,a0
          moveq     #0,d1               ; Flag PAR = 0
          cmpi.l    #'PAR0',d6
            beq.s   pu_set
          moveq     #-1,d1              ; Flag SER = -1
          cmpi.l    #'SER0',d6
            bne     iou_ipar
pu_set
          move.b    d1,par_usef(a0)
          moveq     #0,d0
pu_rts
          rts

;         BASIC - Procedure   'FLP_STEP'
flpstep   jsr       flpglnk(pc)         ; link FLP0 ddd -> a0
            bne.s   st_rts
          jsr       ut_gxin(pc)
            bne.s   st_rts
          lea       fdd_step-$18(a0),a2 ; Zeiger auf step rate
          move.l    (a2),d7             ; alten Wert retten, falls Fehler
          clr.l     (a2)                ; default 6ms
          cmp.w     fdd_maxd-$18(a0),d3
            ble.s   st_dbf
          move.w    fdd_maxd-$18(a0),d3 ; auf fdd_maxdrive begrenzen
          bra.s     st_dbf
st_ploop
          move.w    0(a6,a1.l),d1       ; Parameter Integer
            beq.s   st_dflt             ; =0, nix machen
            bmi.s   st_err              ; 0<, Fehler
;-          cmpi.w    #12,d1              ; >12, Fehler
          cmpi.w    #6,d1               ; >6, Fehler
            bgt.s   st_err
          move.b    st_tab-1(pc,d1.w),d1  ; bersetzung in bits WD1772
            bmi.s   st_err
          move.b    d1,(a2)             ; step rate setzen
st_dflt   addq.l    #2,a1
          addq.l    #1,a2
st_dbf    dbf       d3,st_ploop         ; nchstes Laufwerk
denok     moveq     #0,d0
st_rts    rts
st_err
          move.l    d7,fdd_step-$18(a0) ; bei Fehler, nichts verndern
denbp     moveq     #-$0F,d0            ; ERR_BP
denrts    rts

st_tab    dc.b      -1,2,3,-1,-1,0      ;,-1,-1,-1,-1,-1,1,-1
;         ms         1 2 3  4  5 6      ;  7  8  9 10 11 12    weg, kein Platz

;         BASIC - Procedure   'FLP_DENSITY'
flpdens   jsr       flpglnk(pc)         ; link FLP0 ddd -> a0
            bne.s   denrts
          jsr       ut_gxin(pc)         ; get n integer
            beq.s   denint
          jsr       ut_gxnm1(pc)        ; get 1 string
            bne.s   denrts              ; ..war nix

; FLP_DENSITY H ( default density HD for format )
          cmpi.w    #$0001,$00(a6,a1.l) ; string mit Lnge 1 ?
            bne.s   denbp
          move.b    $02(a6,a1.l),d2     ; S, D oder H
          bsr.s     dencod              ; S->-1, D->0, H->+1
            bne.s   denbp
          move.b    d1,fdd_defd-$18(a0) ; default density setzen
          bra.s     denatr
dencod
          move.l    #0+'HDS',d0
          andi.b    #$DF,d2
          moveq     #-$01,d1
denloop   cmp.b     d2,d0
            beq.s   denok
          addq.l    #$01,d1
          lsr.l     #$08,d0
            bne.s   denloop
denbp1    bra.s     denbp

; FLP_DENSITY 1,1,0 ( Drei Laufwerke: HD,HD,DD )
denint
          cmpi.w    #8,d3               ; mehr als 8 Parameter ?
            bgt.s   denbp1
          move.w    d3,fdd_maxd-$18(a0) ; Anzahl Laufwerke
          moveq     #0,d0               ; alle DD
          moveq     #0,d2               ; bit-nr
          bra.s     dendbf
denplp
          move.w    0(a6,a1.l),d1       ; Parameter integer
            ble.s   dendd               ; -1,0 DD
          bset      d2,d0               ;    1 HD
dendd
          addq.l    #1,d2               ; nchstes bit
          addq.l    #2,a1               ; nchster Parameter
dendbf    dbf       d3,denplp
          move.b    d0,fdd_maxr-$18(a0)
denatr    jsr       atrdev1(pc)         ; Parameter -> ATRdev bernehmen
          bra.s     trck_ok


;         BASIC - Procedure   'FLP_PREC'
flpprec   bsr.s     flp_gpar
            bne.s   trck_rts
          moveq     #$7F,d0
          and.w     0(a6,a1.l),d0       ; auf 127 begrenzen
          move.b    d0,fdd_prec-$0018(a0)
          bra.s     denatr              ; Parameter -> ATRdev bernehmen

;         BASIC - Procedure   'FLP_TRACK'
flptrack  bsr.s     flp_gpar
            bne.s   trck_rts
          move.w    $00(a6,a1.l),fdd_maxt-$0018(a0)         ; $00BA(a0)
trck_ok   moveq     #0,d0
trck_rts  rts

;         BASIC - Procedure   'FLP_START'  (in 20 ms - Schritten)
flpstart  bsr.s     flp_gpar
            bne.s   trck_rts
          moveq     #$7F,d0             ; auf 2.5 sec begrenzen
          and.w     $00(a6,a1.l),d0
            bne.s   strt_df
          moveq     #$20,d0               ; default 640 ms
strt_df   move.b    d0,fdd_rnup-$0018(a0)
          bra.s     denatr              ; Parameter -> ATRdev bernehmen

;         BASIC - Procedure   'FLP_SEC'
flpsec    bsr.s     flp_gpar
            bne.s   trck_rts
          cmpi.w    #1,0(a6,a1.l)
          shi       fdd_sec-$0018(a0)   ; 0 oder -1
          bra.s     trck_ok
flp_gpar
          jsr       ut_gxin1(PC)
            bne.s   gp_err
flpglnk
          move.l    #'FLP0',d7
          jsr       iou_flnk(PC)
gp_err    rts

;+++
; Basic - Erweiterungen ATR_USE, ATR_DEV, ATR_CONV
;---
;         BASIC - Procedure   'ATR_USE'
atruse    move.l    #'ATR0',d7
          jmp       iou_use(pc)

; Zeiger auf id_flag von ATRconv, falls FLP0/ATR0 noch nicht da war
; wird in dd_at_init aus BASIC-nametable geholt
          dc.w      id_flag-atrdev1

;         BASIC - Procedure   'ATR_DEV', 2. Aufruf
atrdev1   bsr.s     atr_flnk            ; Link -> a0
            bne.s   cv_rts
          lea       -$0018(a0),a3       ; a3 ATR0 ddd
          movea.l   fdd_flpl(a3),a0     ; a0 FLP0 ddd
          st        fdd_new(a3)
;-          jmp       init_new(pc)        ; Parameter von FLP0 ddd holen
          movea.l   fdd_init(a3),a1     ; Adresse von init_new - Routine
          jmp       (a1)                ; Parameter (a0) -> (a3)

;         BASIC - Procedure   'ATR_CONV'
atrconv
          bsr.s     atr_gpar            ; get 1 word integer + link
            bne.s   cv_err
          lea       fdd_cadr-$18(a0),a2
          lea       fdd_conv-$18(a0),a3
          move.l    (a2),d3             ; Listenadresse gesetzt ?
            ble.s   err_ni              ; ..nein, ERR_NI
          moveq     #-$0F,d0            ; ERR_BP
          move.w    0(a6,a1.l),d1       ; Parameter 0..2 ?
            bmi.s   cv_err              ; <0
          moveq     #2,d2
          cmp.w     d2,d1
            bgt.s   cv_err              ; >2
          cmp.b     d2,d1               ; Liste 1 oder 0
            blt.s   cv_lis1             ; ..ja, immer da
          movea.l   d3,a1
          tst.l     cv_qi2(a1)          ; Listen 2 vorhanden ?
            beq.s   cv_err              ; ..nein, ERR_BP
cv_lis1   move.b    d1,(a3)             ; fdd_conv ATR_CONV setzen
cv_ok     moveq     #0,d0
cv_rts    rts
err_ni
          sf        (a3)                ; fdd_conv false
          moveq     #-$13,d0            ; ERR_NI
cv_err    tst.l     d0
          rts

atr_gpar
          jsr       ut_gxin1(pc)
            bne.s   cv_err
atr_flnk
          move.l    #'ATR0',d7
          jmp       iou_flnk(pc)


; ---------------------------------------
; xdef iou_use
iou_use   move.l    d7,d6
          cmpa.l    a3,a5
            beq.s   L8044
          jsr       ut_gxnm1(pc)        ; get 1 name or string
            bne.s   L804E
          subq.w    #$03,$00(a6,a1.l)
            bne.s   iou_ipar
          move.l    $02(a6,a1.l),d6
          andi.l    #$5F5F5F00,d6
          addi.b    #$30,d6
L8044     bsr.s     iou_flnk
            bne.s   L804E
          move.l    d6,$0026(a0)        ; iod_dnus+2  $003E-$0018
          moveq     #$00,d0
L804E     rts

; xdef iou_flnk
iou_flnk  moveq     #$00,d0             ; MT_INF
          trap      #$01
          movea.l   $0048(a0),a0        ; SV_DDLST
          move.l    a0,d1
            beq.s   iou_ipar
L805C     cmp.l     $002C(a0),d7        ; iod_dnam+2 $0044-$0018
            beq.s   L806A
          movea.l   (a0),a0
          move.l    a0,d1
            bne.s   L805C
iou_ipar
          moveq     #-$0F,d0            ; ERR_BP
L806A     rts

      end

