; Load ATR Floppy root dir                        21.04.91 Jo
; DD / HD

          section   at

          xdef      at_ldrdr

          xref      at_rsecl

          include   'keys_hdr'
          include   'keys_iod'
          include   'keys_err'
          include   'dd_fq_ddlk'
          include   'dd_fq_QL5A'

;+++
; Load ATR Floppy root dir. Die Routine setzt voraus, da die QL-map (a5)
; schon eingelesen ist. Setzt flp_eodr(a5)
;
;         a4 c  p   Zeiger auf phys def block
;         a5     r  Zeiger auf QL map
;---
at_ldrdr
ldr.reg   reg       d5/d7/a1
          movem.l   ldr.reg,-(sp)
          lea       fdd_hdir(a4),a1
          lea       fdd_map(a4),a5
          move.w    ibm_dir(a5),d7      ; Anzahl Eintrge in root dir
            ble.s   ldr_mchk            ; notausgang
          lsr.w     #4,d7               ; /16 Eintrge pro Sektor = Anz. Sekt.
          moveq     #0,d0
          move.w    ibm_fdir(a5),d0     ; erster Sektor des root dir
          add.w     d0,d7               ; letzter Sektor des root dir
          move.l    d0,d5
ldr_rloop
          jsr       at_rsecl(pc)        ; 1 sector lesen -> a1
            bne.s   ldr_rts
          addq.w    #1,d5               ; nchster Sektor
          cmp.w     d7,d5               ; letzter Sektor ?
            bge.s   ldr_ok              ; ..ja, fertig ok
          move.w    d5,d0
          adda.w    #$200,a1
          bra.s     ldr_rloop
ldr_ok
          lea       fdd_hdir(a4),a1
          move.w    ibm_dir(a5),d7      ; max Anzahl Eintrge rootdir ($70)
          moveq     #hdr.len,d0
          moveq     #0,d5               ; Lnge rootdir QL
          bra.s     ldr_zdbf
ldr_zlop  tst.b     (a1)
            beq.s   ldr_end
          add.l     d0,d5               ; + $40 dazu
          adda.w    #$20,a1
ldr_zdbf  dbf       d7,ldr_zlop
ldr_end
          moveq     #0,d0
ldr_rts
          asl.l     #7,d5
          lsr.w     #7,d5
          move.l    d5,flp_eodr(a5)     ; in block / byte form
          movem.l   (sp)+,ldr.reg
          tst.l     d0
          rts
ldr_mchk
          move.l    iod_hdrl(a4),d5     ; inbuilt header length
          moveq     #err.mchk,d0
          bra.s     ldr_rts
     end
