; QL check ready              1991 Jo
; fr DD / HD   08.03.92

        section fq

        xdef    fq_ckrdy

        include 'flp1_keys_karte'
        include 'flp1_dd_fq_ddlk'

;+++
; QL Check Ready Routine. Testet, ob eine (formatierte) Diskette eingelegt
;                         ist, indem die Indeximpulse gesucht werden.
; Die Routine setzt voraus, da ein Typ I Command ( restore, seek...) luft,
; und da Interrupt Level 7 gesetzt ist.
; Die Routine kehrt bei seek SOFORT mit ok zurck und wird nur bei restore
; ausgefhrt.
;
;       a2 c    WD1772
;       d0   r  0 Diskette eingelegt, -$10 Laufwerk leer
;       a2 c    WD1772
;       a3 c    floppy linkage block
;---
fq_ckrdy
ckr.lreg  reg   d1/d2
;-        movem.l ckr.lreg,-(sp)
        move.l  d1,-(sp)

        tst.b   fdd_ctrk(a3)            ; track-nr zum suchen
          bgt.s ckr_ok                  ; ..ist kein restore, sondern seek
; fdd_ctrk =$FF unkown, =$00 restore
        move.l  fdd_time(a3),d0         ; $20000 normal, $40000 AUTO-BOOT
;-        lsr.l   #1,d0                   ; $10000       , $20000
        moveq   #fds..ind,d1            ; bit 1 INDEX IMPULS
ckr_onlp
        btst    d1,(a2)
          bne.s ckr_offl                ; INDEX = 1, ok
        subq.l  #1,d0
          blt.s ckr_err                 ; INDEX geht nicht auf 1 ( ??? )
        btst    d1,(a2)
          beq.s ckr_onlp                ; immer noch 0, warten
ckr_offl
        btst    d1,(a2)
          beq.s ckr_ok                  ; INDEX = 0, ok
        subq.l  #1,d0
          blt.s ckr_err                 ; INDEX nicht 0, keine Diskette drin !
        btst    d1,(a2)
          bne.s ckr_offl                ; immer noch 1, warten
ckr_ok
        moveq   #0,d0                   ; INDEX Impuls war da, ok
        bra.s   ckr_ret
ckr_err
        move.b  #fdd.at17,fdd_actm(a3)  ; ..go
        moveq   #-$10,d0      ; ERR_FE
ckr_ret
;-        movem.l (sp)+,ckr.lreg
        move.l  (sp)+,d1
        tst.l   d0
        rts
    end
