; Floppy Disk load map    V2.00    1990   Tony Tebby QJUMP   Jo 11.03.92
; DD / HD
; Bugfix move.b $0000007F,$00D7(a3)  03.11.94

        section fq

        xdef    fq_ldmap

        xref    fq_rsecp
        xref    fq_rsecl
        xref    fq_setp

        include 'keys_err'
        include 'dd_fq_ddlk'
        include 'dd_fq_QL5A'
;+++
; This loads the map from a QL5A (DD) or QL5B (HD) Floppy Disk
;
;       d6 c  p msw drive nr
;       a2 c  p WD1772
;       a3 c  p pointer to linkage block
;       a4 c  p pointer to drive definition
;       a5 cr   pointer to map
;
;       status return 0 or err.mchk
;---
fq_ldmap
fdl.reg reg     a1
        movem.l fdl.reg,-(sp)
;***        move.l  a1,-(sp)
        st      fdd_actm(a3)            ;+
        lea     fdd_map(a4),a5

        move.b  fdd_mode(a4),$14(a2)    ; $3FD4
        movea.l a5,a1
        moveq   #1,d0
        jsr     fq_rsecp                 ; read root sector
          beq.s fdl_mset

        move.l  d6,d0
        swap    d0                      ; drive nr 1..4
        subq.w  #1,d0                   ; drive bit nr 0..3
        btst    d0,fdd_maxr(a3)         ; do not change mode
          beq.s fdl_mchk
        bchg    #0,fdd_mode(a4)         ; change mode
        move.b  fdd_mode(a4),$14(a2)    ; $3FD4
        movea.l a5,a1
        moveq   #1,d0
        jsr     fq_rsecp                 ; read root sector again
          bne.s fdl_mchk
fdl_mset
        move.l  flp_id(a5),d0            ; 'QL5A' oder 'QL5B'
        subq.b  #1,d0
        bset    #0,d0                    ; jetzt immer 'QL5A' oder ?
        cmpi.l  #flp.id,d0               ; correct map?
          bne.s fdl_mchk

        moveq   #1,d0                    ; next sector
        jsr     fq_setp
        jsr     fq_rsecp                 ; read it
          bne.s fdl_mchk

        moveq   #2,d0                    ; next sector
        jsr     fq_setp
        jsr     fq_rsecp                 ; read it
          bne.s fdl_mchk

        tst.b   fdd_mode(a4)
          ble.s fdl_exit                ; DD fertig

        moveq   #3,d0                    ; next sector
        jsr     fq_setp
        jsr     fq_rsecp                 ; read it
          bne.s fdl_mchk

        moveq   #4,d0                    ; next sector
        jsr     fq_setp
        jsr     fq_rsecp                 ; read it
          bne.s fdl_mchk

        moveq   #5,d0                    ; next sector
        jsr     fq_setp
        jsr     fq_rsecp                 ; read it
          bne.s fdl_mchk
fdl_exit
        move.b  #fdd.at17,fdd_actm(a3)
        movem.l (sp)+,fdl.reg
;***        move.l  (sp)+,a1
        tst.l   d0
        rts
fdl_mchk
        moveq   #err.mchk,d0
        bra.s   fdl_exit
     end
