; Floppy Set Physical Sector  V2.00    1990   Tony Tebby QJUMP   Jo

        section fq

        xdef    fq_setp

        include 'flp1_dd_fq_QL5A'

;+++
; Floppy Set Physical track+side+sector
;
;       d0 cr   group + sector / track+side+sector
;       a5 c  p pointer to map
;---
fq_setp
fdsp.reg reg    d1/d2
        movem.l fdsp.reg,-(sp)
        move.l  d0,d1
        swap    d1
        mulu    flp_allc(a5),d1
        ext.l   d0
        add.l   d1,d0                    ; physical sector number

        divu    flp_scyl(a5),d0          ; sector+side / cylinder
        move.w  d0,d2                    ; cylinder (track)
        swap    d0
        move.w  d0,d1                    ; sector
        move.b  flp_lgph(a5,d1.w),d1     ; translated sector
        move.w  d1,d0
        add.w   d0,d0                    ; set side
        bclr    #7,d1                    ; (remove side from sector number)

        mulu    flp_soff(a5),d2          ; sector offset
        add.w   d1,d2
        divu    flp_strk(a5),d2          ; in range
        swap    d2
        addq.b  #1,d2                    ; +1 for IBM standard
        move.b  d2,d0                    ; sector

        movem.l (sp)+,fdsp.reg
        rts
        end
