; Ram Disk Format Drive / mit mdv-Laden                Jo 1991

          section   rd

          xdef      rd_fdrv

          xref      rd_fmdv             ; Routine zum MDV-Lesen
;          xref      rd_ckmdv            ; FORMAT ram0_mdv0 checken
          xref      rd_free             ; heap freigeben
          xref      gu_achpp            ; heap holen

;+++
; This formats a Ram Disk on a QL
;
;       d1  r   good groups
;       d2  r   total groups
;       d6 c  p msw drive number
;       a1 c  p medium name
;       a3 c  p dd linkage block
;       status return standard
;---
rd_fdrv
L14D0     jsr       rd_free(pc)   ;L128A
          moveq     #$00,d2
          move.w    (a1)+,d1
          subq.w    #$05,d1
            ble.s   L1550
          addq.l    #$05,a1
          jsr       rd_ckmdv(PC)        ; "RAM0_MDV0" ?
          movea.l   d0,a4
            bgt.s   L1506               ; ..ja
          movea.l   a1,a0
          move.l    a0,d7
          add.l     d1,d7
          movea.l   a7,a1
          subq.l    #$02,a7
          move.l    a6,-(a7)
          suba.l    a6,a6
          movea.w   $00000102,a2        ; CN_DTOI
          jsr       (a2)
          movea.l   (a7)+,a6
          move.w    (a7)+,d2
          cmp.l     a0,d7
            bne.s   L1556
          tst.l     d0
            bne.s   L1556
L1506
          move.l    d2,$0020(a5)
          move.w    d2,d0
            beq.s   L1550
          cmpi.w    #$0003,d0
            blt.s   L1556
          mulu      #$0210,d0
          addq.l    #$08,d0
          jsr       gu_achpp(pc)  ;L6C14(PC)
            bne.s   L1554
          move.l    a4,d0
            bgt.s   L155A
          lea       $0004(a0),a1
          move.w    d2,(a1)
          subq.w    #$02,(a1)+
          move.w    d2,(a1)+
          move.l    a1,(a5)
          st        $000B(a1)
          move.w    d2,d0
          subq.w    #$02,d0
          move.l    a1,$0010(a1)
          adda.w    #$0210,a1
          move.l    a1,-$01FC(a1)
L1544
          adda.w    #$0210,a1
          move.l    a1,(a0)
          movea.l   a1,a0
          subq.w    #$01,d0
            bgt.s   L1544
L1550
          move.w    d2,d1
          moveq     #$00,d0
L1554     rts
L1556
          moveq     #-$0C,d0            ; ERR_BN
          rts

L155A     jmp       (a4)                ; rd_fmdv - Routine

;+++
; Check Medium-Name fr "FORMAT RAM0_MDV0"
;
;         d1.w c/r  Restlnge Mediumname / mdv-Nr 1..8
;         d2.w   r  Anzahl Sektoren auf 255 gesetzt
;         a1   c    Zeiger auf Medium-Name + 5
;
;   status return d0.l ERR_BN normale Ramdisk, + adresse MDV-Ramdisk
;---
rd_ckmdv
          cmpi.w    #$0004,d1           ; name krzer als 9 bytes ?
            blt.s   ckm_bn              ; ja, kein ram0_mdv0
          move.l    #$FFDFDFDF,d0
          and.l     -1(a1),d0           ; _MDV in gro
          cmpi.l    #'_MDV',d0
            bne.s   ckm_bn
          move.b    3(a1),d1            ; mdv-Laufwerk-nr
          subi.b    #$30,d1             ; ..zwischen '1'
            ble.s   ckm_bn
          cmpi.b    #$08,d1
            bgt.s   ckm_bn              ; ..und '8'
          move.w    #$00FF,d2           ; d2.w   255 Sektoren
          lea       rd_fmdv(pc),a4      ; format_ram_mdv-Rotine
          move.l    a4,d0               ; flag + ok
          rts
ckm_bn
          moveq     #-$0C,d0            ; normale Ramdisk
          rts
     end
